#include <stdio.h>
#include <stdlib.h>

#if !defined(SLLIST_H)
#define SLLIST_H
typedef int KeyT;
typedef struct nodetype
{
  KeyT key; /* an optional field */
  /* .. other useful data fields */
  struct nodetype *prev; /* link to previous node */
  struct nodetype *next; /* link to next node */
} NodeT;
typedef struct
{
	NodeT *first;
	NodeT *last;
} ListHeaderT;
typedef ListHeaderT *ListT; 

extern FILE *fpIn, *fpOut;

extern ListT createEmpty();
extern NodeT *createNode( const KeyT givenKey );
extern NodeT *findFromFront( const KeyT givenKey, const ListT L);
extern NodeT *findFromEnd( const KeyT givenKey, const ListT L);
extern void insertAtFront( NodeT *p, ListT L);
extern void deleteAtFront( const ListT L);
extern void deleteAtEnd( const ListT L);
extern void insertAtEnd( NodeT *p, ListT L);
extern void insertBeforeKey( KeyT givenKey, NodeT *p, ListT L );
extern void insertAfterKey( KeyT givenKey, NodeT *p, ListT L );
extern int deleteByKey( KeyT givenKey, ListT L );
extern void deleteList( ListT L );
extern NodeT *front( ListT L );

#endif
